;=========================================================
; Guard Chuck
; By Erik557
;=========================================================
; Description: A chuck that will chase Mario when he gets
; nearby.
; Uses first extra bit: NO
;=========================================================

!Distance      = $0040

print "INIT ",pc
       LDA #$30
       STA $1540,x
       LDA $E4,x
       AND #$10
       LSR #4
       STA $157C,x
       LDA #$04
       STA $C2,x
       JSR SubHorizPos
       TYX
       LDA.l $018526,x
       LDX $15E9
       STA $151C,x
       RTL

DATA_018526:
       db $00,$04
DATA_02C213:
       db $01,$02,$03,$02
DATA_02C228:
       db $40,$10
DATA_02C22A:
       db $03,$01
DATA_02C73D:
       db $0A,$0B,$0A,$0C,$0D,$0C
DATA_02C743:
       db $0C,$10,$10,$04,$08,$10,$18
DATA_02C132:
       db $30,$20,$0A,$30
DATA_02C136:
       db $05,$05,$05,$05
DATA_02C1F3:
       db $01,$03,$02,$02
d02C743b:
       db $04,$08,$08,$0C
d02C73Db:
       db $0A,$0C,$0D,$0C

print "MAIN ",pc
       PHB
       PHK
       PLB
       LDA $187B,x
       PHA
       JSR GuardChuck
       PLA
       BNE +
       CMP $187B,x
       BEQ +
       LDA $163E,x
       BNE +
       LDA #$28
       STA $163E,x
+      PLB
       RTL

NotNormal:
       LDA $14
       LSR #2
       AND #$03
       TAY
       LDA DATA_02C213,y
       STA $151C,x
       ; Satanism
       LDA #$96
       STA $9E,x
       PEA.w ($02)|(GuardChuck>>16<<8)
       PLB
       PHK
       PEA.w .Return-1
       PEA $B888
       JML $02C81A
.Return
       PLB
       LDA #$36
       STA $9E,x
       RTS

GuardChuck:
       LDA $14C8,x
       CMP #$08
       BNE NotNormal
       LDA $15AC,x
       BEQ +
       LDA #$05
       STA $1602,x
+      LDY #$46
       LDA $C2,x
       CMP #$04
       BEQ +
       LDY #$96
+      TYA
       STA $9E,x
       PEA.w ($02)|(GuardChuck>>16<<8)
       PLB
       PHK
       PEA.w .Return-1
       PEA $B888
       JML $02C81A
.Return
       LDA #$36
       STA $9E,x
       LDA $9D
       BEQ RunChuckCode
       PLB
       RTS

RunChuckCode:
       PHK
       PEA.w .RetInteract-1
       PEA $B888
       JML $02C79D
.RetInteract
       PLB
       LDY #$00
       JSR SubOffScreen
       JSL $018032
       JSL $019138
       LDA $1588,x
       AND #$08
       BEQ +
       LDA #$10
       STA $AA,x
+      LDA $1588,x
       AND #$03
       BEQ .NoObjTouch
       LDA $15A0,x
       ORA $186C,x
       BNE .OffScreen
       LDA $187B,x
       BEQ .OffScreen
       LDA $E4,x
       SEC
       SBC $1A
       CLC
       ADC #$14
       CMP #$1C
       BCC .OffScreen
       LDA $1588,x
       AND #$40
       BNE .OffScreen
       LDA $18A7
       CMP #$2E
       BEQ +
       CMP #$1E
       BNE .OffScreen
+      LDA $1588,x
       AND #$04
       BEQ .OnAir
       BEQ .OnAir
       PEA.w ($02)|(GuardChuck>>16<<8)
       PLB
       PEI ($9A)
       PEI ($98)
       JSL $028663
       LDA #$02
       STA $9C
       JSL $00BEB0
       REP #$20
       PLA
       SEC
       SBC #$0010
       STA $98
       PLA
       STA $9A
       SEP #$20
       JSL $028663
       LDA #$02
       STA $9C
       JSL $00BEB0
       PLB
       BRA .NoObjTouch

.OffScreen
       LDA $1588,x
       AND #$04
       BEQ +
       LDA #$C0
       STA $AA,x
       JSL $01801A
       BRA .Continue

.NoObjTouch
       JSL $018022
.OnAir
+      LDA $1588,x
       AND #$04
       BEQ .Continue
       STZ $B6,x     ;\ JSR $02C579
       STZ $AA,x     ;/
.Continue
       JSL $01801A
       LDY $164A,x
       CPY #$01
       LDY #$00
       LDA $AA,x
       BCC +
       INY
       CMP #$00
       BPL +
       CMP #$E0
       BCS +
       LDA #$E0
+      CLC
       ADC DATA_02C22A,y
       BMI +
       CMP DATA_02C228,y
       BCC +
       LDA DATA_02C228,y
+      TAY
       BMI ..Execute
       LDY $C2,x
       CPY #$07
       BNE ..Execute
       CLC
       ADC #$03
..Execute
       STA $AA,x
       LDA $C2,x
       JSL $0086DF

       dw fuk2
       dw fuk
       dw EitherLookOrChase
       dw Stomp
       dw Dig
       dw Catch

fuk:
       PEA.w ($02)|(GuardChuck>>16<<8)
       PLB
       PHK
       PEA.w .Return-1
       PEA $B888
       JML $02C6A7
.Return
       PLB
+      RTS

fuk2:
       PEA.w ($02)|(GuardChuck>>16<<8)
       PLB
       PHK
       PEA.w .Return-1
       PEA $B888
       JML $02C63B
.Return
       PLB
       RTS

Dig:
       LDA $14
       LSR #6
       AND #$01
       ASL
       ORA $157C,x
       TAY
       LDA DATA_02C1F3,y
       STA $151C,x
       LDA #$05
       STA $1602,x
       lda $1337
       LDA $14E0,x
       XBA
       LDA $E4,x
       REP #$20
       SBC $94
       ADC.w #!Distance
       CMP.w #!Distance*2
.Common
       SEP #$20
       BCS .Return
       JSR SubHorizPos
       TYA
       CMP $157C,x
       BNE .Return
       LDA #$1E
       STA $1DFC
       LDA #$01
       STA $1FD6,x
       INC $C2,x
       LDA #$0B
       STA $1540,x
.Return
       RTS

Stomp:
       LDY $1570,x
       LDA $1540,x
       BNE +
       INC $1570,x
       INY
       CPY #$07
       BEQ EndStomp
       LDA DATA_02C743,y
       STA $1540,x
+      LDA DATA_02C73D,y
       STA $1602,x
       LDA #$02
       CPY #$05
       BNE +
       LDA $14
       LSR
       ;NOP
       AND #$02
       INC
+      STA $151C,x
       RTS

Catch:
       LDY $1570,x
       LDA $1540,x
       BNE +
       INC $1570,x
       INY
       CPY #$03
       BEQ EndStomp
       LDA d02C743b,y
       STA $1540,x
+      LDA d02C73Db,y
       STA $1602,x
       RTS

EndStomp:
       LDA #$30
       STA $1540,x
       LDA #$02
       STA $C2,x
       INC $187B,x
       JMP DirStuff

EitherLookOrChase:
       LDA #$03
       STA $1602,x
       LDA $1540,x
       BNE .Return
       LDA #$08      ;\ JSR $02C628
       STA $15AC,x   ;/
       LDA #$01
       STA $C2,x
       LDA #$40
       STA $1540,x
.Return
       RTS

DirStuff:
       JSR SubHorizPos      ;\
       TYA                  ; | JSR $02C556
       STA $157C,x          ; |
       LDA DATA_018526,y    ; |
       STA $151C,x          ;/
Return:
       RTS

;========================
; Misc. subroutines
;========================

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
  SubOffScreen:           ;; - Optimized version
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Argument
; Y : type (#$00=X0, #$02=X1 ... #$0E=X7)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
       
       LDA $15A0,x
       ORA $186C,x
       BEQ .Return2
       LDA $167A,x
       AND #$04
       BNE .Return2
       LDA $5B
       LSR A
       BCS .VerticalLevel
       LDA $D8,x
       ADC #$50
       LDA $14D4,x
       ADC #$00
       CMP #$02
       BCS .EraseSprite
       LDA $14E0,x
       XBA
       LDA $E4,x
       REP #$21
       ADC .AddTable,y
       SEC
       SBC $1A
       CMP .CmpTable,y
.Common
       SEP #$20
       BCC .Return2
.EraseSprite
       LDA $14C8,x
       CMP #$08
       BCC .KillSprite
       LDY $161A,x
       CPY #$FF
       BEQ .KillSprite
       LDA $1938,y
       AND #$FE
       STA $1938,y
.KillSprite
       STZ $14C8,x
.Return2
       RTS

.VerticalLevel
       LDA $13
       LSR A
       BCS .CheckY
       LDA $14E0,x
       XBA
       LDA $E4,x
       REP #$21
       ADC.w #$0040
       CMP.w #$0280
       BRA .Common
.CheckY
       LDA $14D4,x
       XBA
       LDA $D8,x
       REP #$20
       SBC $1C
       CLC
       ADC.w #$0070
       CMP.w #$01D0
       BRA .Common

.AddTable
       dw $0040,$0040,$0010,$0070
       dw $0090,$0050,$0080,$FFC0
.CmpTable
       dw $0170,$01E0,$01B0,$01D0
       dw $0230,$01B0,$0220,$0160

;==================
  SubHorizPos:
;==================

       LDY #$00
       LDA $94
       SEC
       SBC $E4,x
       STA $0F
       LDA $95
       SBC $14E0,x
       BPL $01
       INY
       RTS

;==================
  SubVertPos:
;==================
       LDY #$00
       LDA $96
       SEC
       SBC $D8,x
       STA $0E
       LDA $97
       SBC $14D4,x
       BPL $01
       INY
       RTS

